import datetime
import json
import time
import traceback

from pandas import DataFrame

from applications import aiditApi, log, bot
from applications.db import DatabaseConnector
from config import long_articles_config


class CategoryColdStartTask:
    def __init__(self):
        self.db_client = DatabaseConnector(long_articles_config)
        self.db_client.connect()

    def insert_crawler_plan(self, crawler_plan_id,crawler_plan_name, create_timestamp):
        insert_query = f"""
            insert into article_crawler_plan (crawler_plan_id, name, create_timestamp) values (%s, %s, %s);
        """
        try:
            self.db_client.save(
                query=insert_query,
                params=(crawler_plan_id, crawler_plan_name, create_timestamp)
            )
        except Exception as e:
            bot(
                title="品类冷启任务，记录抓取计划id失败",
                detail={
                    "error": str(e),
                    "error_msg": traceback.format_exc(),
                    "crawler_plan_id": crawler_plan_id,
                    "crawler_plan_name": crawler_plan_name
                }
            )

